// RNProtokoll.cpp: Implementierung der Klasse CRNProtokoll.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RNProtokoll.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
// Klasse Fr das Protokoll kommt wenn es mal definert ist
//////////////////////////////////////////////////////////////////////

CRNProtokoll::CRNProtokoll()
{
	m_bTxBcc = 0;
	m_bLength = 0;
	m_bFrameCount = 0;
}

CRNProtokoll::~CRNProtokoll()
{

}

BYTE CRNProtokoll::GetLevel0(BYTE* Buffer)
{
	if(Buffer)
	{
		memcpy(Buffer,&m_bLowLevel,m_bLength);
	}
	return m_bLength;
}

bool CRNProtokoll::SetByteDataDecode(BYTE* Buffer,BYTE Len)
{
	// Daten in den Stream schreiben und Maskieren
	// Framen
	BYTE x=0;
	BYTE bLenAdd = 1; 
	m_bLowLevel[0] = CTL_C_STX;
	for(x=0;x<Len;x++)
	{
		if((Buffer[x] & CTL_M_MASK) == CTL_C_BASE)
		{
			m_bLowLevel[x+bLenAdd] = CTL_C_PFX;
			bLenAdd++;
			m_bLowLevel[x+bLenAdd] = Buffer[x] | CTL_M_ADON;
		}
		else
		{
			m_bLowLevel[x+bLenAdd] = Buffer[x];
		}
		m_bTxBcc ^= Buffer[x];
		
		if((x+bLenAdd+2) >= 1024)
		{
			//Mehr Buffer haben wir nicht
			return false;
		}

		if(x == 127)
		{
			// Neuen Frame an fangen
			// Das mssen wir noch prfen
			m_bLowLevel[x+bLenAdd] = m_bTxBcc;
			m_bLowLevel[x+bLenAdd+1] = CTL_C_ETX;
			m_bLowLevel[x+bLenAdd+2] = CTL_C_STX;
			bLenAdd = bLenAdd+2;
			m_bTxBcc = 0;
			m_bFrameCount ++;
		}
	}
	m_bLowLevel[x+bLenAdd] = m_bTxBcc;
	m_bLowLevel[x+bLenAdd+1] = CTL_C_ETX;
	m_bLength = Len+2+bLenAdd;

	return true;
}

bool CRNProtokoll::SetByteDataEncode(BYTE *buffer,BYTE len)
{
	memcpy(&m_bLowLevel,buffer,len);
	m_bLength = len;

	return true;
}

bool CRNProtokoll::GetEncode(BYTE *buffer,BYTE& len)
{
	//anfang und ende wird in der com routine geprft drum erst mal hier egal
	BYTE* TempBuffer = new BYTE[m_bLength-2];
	int x = 0;
	int pos = 0;
	bool result = true;
	m_bTxBcc = 0;
	for(x=0;x<m_bLength-3;x++)
	{
		if(m_bLowLevel[x+1] != CTL_C_PFX)
		{
			TempBuffer[pos] = m_bLowLevel[x+1];
			m_bTxBcc ^= TempBuffer[pos];
			pos++;
		}
		else
		{
			TempBuffer[pos] = m_bLowLevel[x+2] & ~CTL_M_ADON;
			m_bTxBcc ^= TempBuffer[pos];
			pos++;
			x++;
		}
	}
	if(m_bTxBcc != m_bLowLevel[m_bLength-2])
	{
		ATLTRACE("Prfsumme ist nicht OK\n");
		result = false;
	}
	len = pos;
	if(buffer)
	{
		memcpy(buffer,TempBuffer,len);
	}
	delete TempBuffer;
	return result;
}
