// MultiCast1.cpp: Implementierung der Klasse CMultiCast.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MultiCast.h"
#include "messages.h"
#include "process.h"
#include "TraceData.h"

extern DWORD  g_dwTraceThreadId;
extern int     g_iTraceLevel;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

#define MCASTPORT		27000



unsigned __stdcall MutiCastThread(LPVOID pParam);
HANDLE g_hInitOKMsg = NULL;

CMultiCast::CMultiCast()
{
    recvsock = 0;
    m_dwMulticastThreadID = 0;
	ownport   = MCASTPORT-1;
}

CMultiCast::~CMultiCast()
{
    if(m_dwMulticastThreadID >0 )
    {
        PostThreadMessage(m_dwMulticastThreadID,WM_SHUTDOWN,NULL,NULL);
        WaitForSingleObject(m_hMulticastThread,30000);
        CloseHandle(m_hMulticastThread);
    }

    if(g_hInitOKMsg)
    {
        CloseHandle(g_hInitOKMsg);
    }

    if(m_bInit)
    {
        if(recvsock > 0)
        {
            closesocket(recvsock);
        }
        if(sockm > 0)
        {
            closesocket(sockm);
        }
		//closesocket(remote);
        WSACleanup();
    }
}

bool CMultiCast::Init()
{
    g_hInitOKMsg = CreateEvent(NULL,true,false,NULL);

    m_hMulticastThread=(HANDLE)_beginthreadex(NULL,0,MutiCastThread,this,CREATE_SUSPENDED,reinterpret_cast<unsigned int*>(&m_dwMulticastThreadID));
	SetThreadPriority(m_hMulticastThread, THREAD_PRIORITY_NORMAL);
    ResumeThread(m_hMulticastThread);

    if(WaitForSingleObject(g_hInitOKMsg,30000) == WAIT_OBJECT_0)
    {
        return true;
    }
    
    return false;
}

bool CMultiCast::InitStreamSokect()
{
    if(WSAStartup(MAKEWORD(2,2), &m_wsd) !=0)
    {

	    TraceIt("WSAStartup() failed");
	    return false;
    }

    multiport = MCASTPORT;
	

    local.sin_family = AF_INET;
    local.sin_port	 =  htons(ownport);
    local.sin_addr.s_addr = inet_addr(m_csOwnIPAdress);
 
    dwmulticastgroup =	inet_addr(m_csIPAdress);
    remote.sin_family = AF_INET;
    remote.sin_port	  = htons(multiport);
    remote.sin_addr.s_addr = dwmulticastgroup;

    if((recvsock = WSASocket(AF_INET,SOCK_DGRAM,0,NULL,0,WSA_FLAG_MULTIPOINT_C_LEAF|WSA_FLAG_MULTIPOINT_D_LEAF|WSA_FLAG_OVERLAPPED)) == INVALID_SOCKET)
    {
	    TraceItF("Socket failed with :%d\n", WSAGetLastError());
	    WSACleanup();
	    return false;
    }

    if(recvsock>0)
    {
        if(bind(recvsock,(struct sockaddr *)&local,sizeof(local)) == SOCKET_ERROR)
        {
	        TraceItF("bind() failed with:%d\n", WSAGetLastError());
	        closesocket(recvsock);
	        WSACleanup();
	        return false;
        }

        if((sockm = WSAJoinLeaf(recvsock, (SOCKADDR *)&remote, sizeof(remote), NULL, NULL, NULL, NULL, JL_BOTH)) == INVALID_SOCKET)
        {

	        TraceItF("WSAJoinLeaf() failed: %d\n", WSAGetLastError());
	        closesocket(recvsock);
	        WSACleanup();
	        return false;
        }

        if(sockm>0)
        {
            int result = WSAAsyncSelect(recvsock,m_hDlgWnd,WM_WSAMESSAGE,FD_ALL_EVENTS);
            if(result == SOCKET_ERROR)
            {
                TraceItF("WSAAsyncSelect() failed: %d\n", WSAGetLastError());
	            closesocket(recvsock);
                closesocket(sockm);
	            WSACleanup();
	            return false;
            }
        }

     }

    return true;
}

void CMultiCast::TraceIt(CString csTrace)
{
    ATLTRACE("%s\n",csTrace.Left(100));

	if(g_iTraceLevel >= 1)
	{
		TraceData* Buffer;
		Buffer = new TraceData;
		Buffer->m_ListBox = 0;
		Buffer->m_TraceString  = "CMultiCast ";
		Buffer->m_TraceString += csTrace;
		PostThreadMessage(g_dwTraceThreadId,WM_TRACEIT,NULL,(long) Buffer);
	}

}

void CMultiCast::TraceItF(LPCTSTR lpszFormat, ...)
{
    CString csDummy;
	ATLASSERT(csDummy._IsValidString(lpszFormat, FALSE));


	va_list argList;
	va_start(argList, lpszFormat);
	csDummy.FormatV(lpszFormat, argList);
    TraceIt(csDummy);
	va_end(argList);
}

HWND CMultiCast::CreateMsgWindow()
{
    return ::CreateWindow("STATIC","MultiCastMsgWindow",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,HWND_MESSAGE,NULL,NULL,NULL);
}


bool CMultiCast::SendData(unsigned char* Data,long Bytes)
{
    int result = 0;
    char SendBuffer[10240];
	memcpy(&SendBuffer,Data,Bytes);
    if((result = sendto(recvsock, SendBuffer, Bytes, 0 , (struct sockaddr *)&from , 0))== SOCKET_ERROR)
	{
        TraceItF("%d Bytes gesendet",result);
    }
    return true;
}

unsigned __stdcall MutiCastThread(LPVOID pParam)
{
    HRESULT hr = CoInitialize(NULL);
    if (FAILED(hr))
    {
        ATLTRACE("\n\n\n************ Oops: Telegram delivery didn't work ... *************\n\n\n");
        Beep(200,100);
        Beep(100,100);
        Beep(200,100);
        return hr;
    }

    MSG msg;

    CMultiCast* m_pMultiCast = (CMultiCast*) pParam;

    m_pMultiCast->m_hDlgWnd = m_pMultiCast->CreateMsgWindow();
    ::PeekMessage(&msg,m_pMultiCast->m_hDlgWnd,WM_APPINIT,WM_APPEND,PM_NOREMOVE);

    
    if(m_pMultiCast->m_hDlgWnd)
    {
        if(m_pMultiCast->InitStreamSokect())
        {
            m_pMultiCast->m_bInit = true;
            SetEvent(g_hInitOKMsg);
            while (1)
            {
                BOOL bRet = GetMessage(&msg,NULL,WM_NULL,WM_APPEND);
                if (msg.message==WM_SHUTDOWN)
                {
			        break;
                }
                else if (msg.message==WM_WSAMESSAGE)
                {
                    try
                    {
				        m_pMultiCast->HandleWASMsg(msg.wParam,msg.lParam);
                    }
                    catch(...)
                    {
                        ::MessageBox(NULL,"Fehler bei Trace","Kommt hoffendlich nie",MB_OK);
                    }
                }
		        if (bRet !=-1)
                {
			        TranslateMessage(&msg);
                    DispatchMessage(&msg);
                }
            }
        }
    }

	ATLTRACE("MutiCastThread stopped\n");
    CoUninitialize();
	_endthreadex(0);
    return 0;
}

void CMultiCast::HandleWASMsg(WPARAM wParam, LPARAM lParam)
{
    TraceIt("WSA Message");

    long ErrorCode =  WSAGETSELECTERROR(lParam);
	long Event = WSAGETSELECTEVENT(lParam);
	if (ErrorCode > 0)
	{
		//m_csErrorMsg = m_cWSAMsg.ShowWSAError(ErrorCode,2);
		//Fire_Error(ErrorCode);

        TraceItF("WSA Message With ErrorCode %d",ErrorCode);
	}
	else
	{
		switch (Event)
		{
			case FD_ACCEPT:
				TraceIt("FD_ACCEPT");
				break;
			case FD_READ:
				TraceIt("FD_READ");
                Receive_Data();
				break;
			case FD_WRITE:
				TraceIt("FD_WRITE");
                break;
			case FD_CLOSE:
				TraceIt("FD_CLOSE");
				break;
			default:
				TraceIt("UNKOWN");
				break;
		}
	}
}

void CMultiCast::Receive_Data()
{
	char recvbuf1[10240];
    memset(&recvbuf1,0,10240);
    int result = 0;
    int	len = sizeof(struct sockaddr_in);

  	if((result = recvfrom (recvsock,recvbuf1,10240 ,0 , (struct sockaddr *)&from ,&len )) == SOCKET_ERROR)
	{
		TraceItF("recvfrom failed with: %d\n", WSAGetLastError());
	}
    else
    {
        TraceItF("recvfrom %s len: %d Data %s",inet_ntoa(from.sin_addr),result,recvbuf1);
        
        CString csDummy;
        csDummy.Format("%s:%s",inet_ntoa(from.sin_addr),recvbuf1);
        char* buffer = new char[csDummy.GetLength()+1];
        strcpy(buffer,csDummy.operator LPCTSTR());
        PostMessage(m_hMainWnd,WM_INCOMMINGDATA,NULL,(LPARAM)buffer);
        
    }
}
