// MNV24.cpp: Implementierung der Klasse CMNV24.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MNV24.h"
#include "messages.h"
#include "TraceData.h"

extern DWORD  g_dwTraceThreadId;
extern int     g_iTraceLevel;

HANDLE  m_hCOM;

OVERLAPPED o;

bool g_wantexit = false;
extern HWND g_hMainDlg;

//extern DWORD   g_dwGobalThreadId;
extern CString g_csPath;
void TraceIt(CString TraceString);
CString BinToTrace(BYTE *Daten, int len);

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

DWORD WINAPI ReadThread(LPVOID pParam);


CMNV24::CMNV24()
{
	m_csCOM = "COM2";
	m_iBaud = 115200;
	m_iBaud = 38400;
	m_hReadThread = NULL;
}

CMNV24::~CMNV24()
{

}

bool CMNV24::Init()
{
	// Initialiesieren der Com
	m_hCOM = CreateFile(m_csCOM.operator LPCTSTR(),GENERIC_WRITE | GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
	if(m_hCOM == INVALID_HANDLE_VALUE)
	{
		return false;
	}
	COMMCONFIG mcomcfg;
	memset(&mcomcfg,0,sizeof(COMMCONFIG));
	mcomcfg.dwSize = sizeof(COMMCONFIG);
	DWORD size = sizeof(COMMCONFIG);
	if(!GetCommConfig(m_hCOM,&mcomcfg,&size))
	{
		return false;
	}
	mcomcfg.dcb.BaudRate = m_iBaud;
	mcomcfg.dcb.ByteSize = 8;
	mcomcfg.dcb.Parity = NOPARITY;
	mcomcfg.dcb.StopBits = ONESTOPBIT;
	mcomcfg.dcb.fDtrControl = DTR_CONTROL_ENABLE;
	mcomcfg.dcb.fRtsControl = RTS_CONTROL_ENABLE;
	size = sizeof(mcomcfg);
	if(!SetCommConfig(m_hCOM,&mcomcfg,size))
	{
		LPVOID lpMsgBuf;     
		FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM |
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &lpMsgBuf,
		0,
		NULL
		);
		CString csErrorMsg = "Fehler beim Iit der Com";
		csErrorMsg +=  (LPCTSTR) lpMsgBuf;
		LocalFree( lpMsgBuf );
		csErrorMsg.Replace("\n","");
		ATLTRACE("%s\n",csErrorMsg);

		MessageBox(NULL,csErrorMsg,"SensorCatch",MB_OK);
		
		return false;
	}
	// Auf welche Events warten wir ?
	if(!SetCommMask(m_hCOM,EV_RXCHAR | EV_DSR | EV_CTS | EV_ERR))
	{
		return false;
	}
	// Puffer leer mach was da jetzt drin ist sollte schrott sein
    PurgeComm(m_hCOM,PURGE_TXCLEAR);
    PurgeComm(m_hCOM,PURGE_RXCLEAR);

	memset(&o,0,sizeof(OVERLAPPED));
	o.hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);

    m_hReadThread=CreateThread(NULL,0,ReadThread,NULL,CREATE_SUSPENDED,(LPDWORD )&m_dwReadThreadId);
    SetThreadPriority(m_hReadThread, THREAD_PRIORITY_NORMAL);
    ResumeThread(m_hReadThread);
	
	return true;
}

DWORD WINAPI ReadThread(LPVOID pParam)
{
    HRESULT hr = CoInitialize(NULL);
    if (FAILED(hr))
    {
        ATLTRACE("\n\n\n************ Oops: Telegram delivery didn't work ... *************\n\n\n");
        Beep(200,100);
        Beep(100,100);
        Beep(200,100);
        return hr;
    }

	MSG msg;
    
	PeekMessage(&msg,(HWND)-1,NULL,NULL,PM_NOREMOVE);

	// Die defins sind in der stdafx.h
	// Hier wir die Com gelesen. 
	bool exit = false;
	DWORD readen;
	BYTE  Buffer[1];
	BYTE  Buffer2[127];
	BYTE  SchrottBuffer[20];
	DWORD Bytes = 1;
	int Bufferpos = 0;
	int SchrottBufferpos = 0;

	while(!exit)
	{
		Bytes = 1;
		readen = 0;
		
		PostMessage(g_hMainDlg,WM_CHANGESTATUS,2,NULL);

        DWORD Bytes = 1;
        ReadFile(m_hCOM,Buffer,1,&readen,&o);
		// Warten bis mindestens ein Zeichen im Buffer der Com
        WaitForSingleObject(o.hEvent,INFINITE);
        GetOverlappedResult(m_hCOM,&o,&Bytes,FALSE);
		
		PostMessage(g_hMainDlg,WM_CHANGESTATUS,1,NULL);

        for(BYTE i=0;i<Bytes;i++)
        {
			Buffer2[Bufferpos] = Buffer[0];
			if (Bufferpos == MAX_FRAME_LENGTH)
			{
				if(Buffer2[0] == CTL_C_STX)
				{
					if(Buffer2[MAX_FRAME_LENGTH] == CTL_C_ETX)
					{
						//gltig
						BYTE* SendBuffer = new BYTE[127];
						memcpy(SendBuffer,Buffer2,126);
						//PostThreadMessage(g_dwGobalThreadId,WM_V24DATA,NULL,(long)SendBuffer);
						PostMessage(g_hMainDlg,WM_V24DATA,126,(long)SendBuffer);
					}
					else
					{
						TraceIt("Frame Error: Over Run");
						TraceIt("V24 Schrott:");
					}
				}
				Bufferpos=0;
			}
			else
			{
				if(Buffer2[0] ==  CTL_C_STX)
				{
					if(Bufferpos>0)
					{
						if((Buffer2[Bufferpos] != CTL_C_ETX) || (Buffer2[Bufferpos-1] == CTL_C_PFX && Buffer2[Bufferpos] != CTL_C_ETX))
						{
							Bufferpos++;
						}
						else
						{
							//gltig
							BYTE* SendBuffer = new BYTE[Bufferpos+1];
							memcpy(SendBuffer,Buffer2,Bufferpos+1);
							//PostThreadMessage(g_dwGobalThreadId,WM_V24DATA,NULL,(long)SendBuffer);
							PostMessage(g_hMainDlg,WM_V24DATA,Bufferpos+1,(long)SendBuffer);
							Bufferpos=0;
						}
					}
					else
					{
						Bufferpos++;
					}
				}
				else
				{
					SchrottBuffer[SchrottBufferpos] = Buffer[0];
					SchrottBufferpos++;
					if(SchrottBufferpos == 20)
					{
						SchrottBufferpos = 0;
						CString csTrace;
						csTrace.Format("Schrott %s",BinToTrace(SchrottBuffer,19));
						TraceIt(csTrace);
					}
					Bufferpos=0;
				}
			}
		}		
		if (g_wantexit)
		{
			exit = true;
		}
	}
	CloseHandle(m_hCOM);
	ATLTRACE("ReadThread stopped\n");
    CoUninitialize();
    ExitThread(0);
    return 0;
}

void TraceIt(CString TraceString)
{
	if(g_iTraceLevel >= 1)
	{
		TraceData* Buffer;
		Buffer = new TraceData;
		Buffer->m_ListBox = 0;
		Buffer->m_TraceString  = "CMain ";
		Buffer->m_TraceString += TraceString;
		PostThreadMessage(g_dwTraceThreadId,WM_TRACEIT,NULL,(long) Buffer);
	}
}

CString BinToTrace(BYTE *Daten, int len)
{
	CString csResult = "";
	for(int x=0;x<len;x++)
	{
		if((Daten[x]<32) || (Daten[x] >122))
		{
			CString csDummy;
			csDummy.Format("<%02X>",Daten[x]);
			csResult += csDummy;
		}
		else
		{
			csResult += Daten[x];
		}
	}
	return csResult;
}

void CMNV24::Deinit()
{
	//Aufrumen
	g_wantexit = true;
	SetEvent(o.hEvent);
	if(m_hReadThread)
	{
		WaitForSingleObject(m_hReadThread,30000);
		CloseHandle(m_hReadThread);
	}
	CloseHandle(o.hEvent);
}


bool CMNV24::WriteOut(BYTE* Buffer,int len)
{
	// Daten auf der Com schreiben
	// PostMessage(g_hMainDlg,WM_CHANGESTATUS,3,NULL);
	// Spter mal auf dem Dialog an zeichen das Daten gesendet werden nur optic
	DWORD written = 0;
	
	OVERLAPPED o;
	
	char Text[1];
	Text[0] = 'a';
	memset(&o,0,sizeof(OVERLAPPED));
	
	o.hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);

	if(!WriteFile(m_hCOM,Buffer,len,&written,&o))
	{
		if(GetLastError() == ERROR_IO_PENDING)
		{
			GetOverlappedResult(m_hCOM, &o, &written, TRUE);
		}
		else
		{
			LPVOID lpMsgBuf;     
			FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR) &lpMsgBuf,
			0,
			NULL
			);
			CString csErrorMsg = "Fehler beim Schreiben auf Com ";
			csErrorMsg +=  (LPCTSTR) lpMsgBuf;
			LocalFree( lpMsgBuf );
			csErrorMsg.Replace("\n","");

			ATLTRACE("%s\n",csErrorMsg);
		}
	}
	CloseHandle(o.hEvent);
	// PostMessage(g_hMainDlg,WM_CHANGESTATUS,4,NULL);
	return true;
}
